Index: imaps-frontend/src/components/Modals/Components/ModalSelectConnections2.jsx
===================================================================
--- imaps-frontend/src/components/Modals/Components/ModalSelectConnections2.jsx	(revision 0c6b92add4cfaedcb91bcd37b45849f142f7d152)
+++ imaps-frontend/src/components/Modals/Components/ModalSelectConnections2.jsx	(revision 0c6b92add4cfaedcb91bcd37b45849f142f7d152)
@@ -0,0 +1,43 @@
+import styles from "../EntranceModal/EntranceModal.module.css";
+import React from "react";
+import PropTypes from "prop-types";
+import MapShape from "../../../scripts/base/MapShape.js";
+
+export default function ModalSelectConnections2({shapeInfo,updateModalData,addConnection,availableShapes}) {
+
+    console.log("shapes modal",availableShapes)
+    return (
+            <div className={styles.formGroup}>
+                <label htmlFor="selectedPin">Select connections:</label>
+                <select
+                    id="selectedPin"
+                    name="selectedPin"
+                    value={shapeInfo.selectedPin}
+                    onChange={updateModalData}
+                >
+                    <option value="">Select Connection</option>
+                    {availableShapes
+                        .filter(
+                            (s) =>
+                                !s.info.selectedPins.includes(shapeInfo.name) &&
+                                s.info.name !== "" &&
+                                s.info.name !== shapeInfo.name
+                        )
+                        .map((othShape, index) => (
+                            <option key={index} value={othShape.info.name}>
+                                {othShape.info.name}
+                            </option>
+                        ))}
+                </select>
+                <button type="button" onClick={addConnection} className={styles.addButton}>
+                    Add Connection
+                </button>
+            </div>
+    )
+}
+
+ModalSelectConnections2.propTypes = {
+    shapeInfo: PropTypes.object,
+    updateModalData: PropTypes.func,
+    addConnection: PropTypes.func,
+}
Index: imaps-frontend/src/components/Modals/Components/ModalSelectRoom.jsx
===================================================================
--- imaps-frontend/src/components/Modals/Components/ModalSelectRoom.jsx	(revision 0c6b92add4cfaedcb91bcd37b45849f142f7d152)
+++ imaps-frontend/src/components/Modals/Components/ModalSelectRoom.jsx	(revision 0c6b92add4cfaedcb91bcd37b45849f142f7d152)
@@ -0,0 +1,24 @@
+import styles from "../EntranceModal/EntranceModal.module.css";
+import React from "react";
+
+export default function ModalSelectRoom({shapeInfo,availableRooms,updateModalData}){
+    return (
+        <div className={styles.formGroup}>
+            <label htmlFor="connectedRoom">Select room associated with entrance:</label>
+            <select
+                id="connectedRoom"
+                name="connectedRoom"
+                value={shapeInfo.connectedRoom}
+                onChange={updateModalData}
+                required
+            >
+                <option value="">Select Room</option>
+                {availableRooms.map((room, index) => (
+                    <option key={index} value={room.info.name}>
+                        {room.info.name}
+                    </option>
+                ))}
+            </select>
+        </div>
+    )
+}
Index: imaps-frontend/src/components/Modals/CreateMapModal/CreateMapModal.jsx
===================================================================
--- imaps-frontend/src/components/Modals/CreateMapModal/CreateMapModal.jsx	(revision 0c6b92add4cfaedcb91bcd37b45849f142f7d152)
+++ imaps-frontend/src/components/Modals/CreateMapModal/CreateMapModal.jsx	(revision 0c6b92add4cfaedcb91bcd37b45849f142f7d152)
@@ -0,0 +1,64 @@
+import React, { useContext, useState } from "react";
+import PropTypes from "prop-types";
+import styles from "./CreateMapModal.module.css";
+
+const CreateMapModal = ({ isOpen, onClose,addMap}) => {
+    const [mapName, setMapName] = useState("");
+    const [mapType, setMapType] = useState("");
+
+    const handleSubmit = (e) => {
+        const mapDetails = {
+            name: mapName,
+            type: mapType,
+        };
+
+        addMap(mapDetails);
+
+        onClose();
+    };
+
+    if (!isOpen) return null;
+
+    return (
+        <div className={styles.modalOverlay} onClick={onClose}>
+            <div className={styles.modalContent} onClick={(e) => e.stopPropagation()}>
+                <h2 className={styles.title}>Enter Map Details</h2>
+                <form onSubmit={handleSubmit} className={styles.formData}>
+                    <label>
+                        Map Name:
+                        <input
+                            type="text"
+                            value={mapName}
+                            onChange={(e) => setMapName(e.target.value)}
+                            required
+                        />
+                    </label>
+                    <label>
+                        Map Type:
+                        <input
+                            type="text"
+                            value={mapType}
+                            onChange={(e) => setMapType(e.target.value)}
+                            required
+                        />
+                    </label>
+                    <div className={styles.modalButtons}>
+                        <button type="submit" className={styles.modalSubmitButton}>
+                            Submit
+                        </button>
+                        <button type="button" className={styles.modalCancelButton} onClick={onClose}>
+                            Cancel
+                        </button>
+                    </div>
+                </form>
+            </div>
+        </div>
+    );
+};
+
+CreateMapModal.propTypes = {
+    isOpen: PropTypes.bool.isRequired,
+    onClose: PropTypes.func.isRequired,
+};
+
+export default CreateMapModal;
Index: imaps-frontend/src/components/Modals/EntranceModal/EntranceModal.jsx
===================================================================
--- imaps-frontend/src/components/Modals/EntranceModal/EntranceModal.jsx	(revision 0c6b92add4cfaedcb91bcd37b45849f142f7d152)
+++ imaps-frontend/src/components/Modals/EntranceModal/EntranceModal.jsx	(revision 0c6b92add4cfaedcb91bcd37b45849f142f7d152)
@@ -0,0 +1,69 @@
+import React, {useState, useEffect} from "react";
+import styles from "./EntranceModal.module.css";
+import PropTypes from "prop-types";
+import {MapBuilder} from "../../../scripts/main/MapBuilder.js";
+
+import Modal from "../Components/Modal.jsx";
+import ModalNameField from "../Components/ModalNameField.jsx";
+import ModalSelectRoom from "../Components/ModalSelectRoom.jsx";
+import ModalSelectConnections from "../Components/ModalSelectConnections.jsx";
+import ModalDisplayConnections from "../Components/ModalDisplayConnections.jsx";
+import ModalDescriptionField from "../Components/ModalDescriptionField.jsx";
+import ModalSaveButton from "../Components/ModalSaveButton.jsx";
+import ModalMainEntranceCheckbox from "../Components/ModalMainEntranceCheckbox.jsx";
+import {useModalEvent} from "../Hooks/useModalEvent.jsx";
+import useModalState from "../Hooks/useModalState.jsx";
+import useConnections from "../Hooks/useConnections.jsx";
+import ModalSelectConnections2 from "../Components/ModalSelectConnections2.jsx";
+import ShapeQuery from "../../../scripts/util/ShapeQuery.js";
+
+export default function EntranceModal({map}) {
+
+    const {
+        modalState: {isOpen,setIsOpen,shape,setShape,shapeInfo,setShapeInfo},
+        handlers: {toggleModal,updateModalData,saveDetails}
+    } = useModalState(map);
+
+    const {
+        connectionState: {connections,setConnections},
+        handlers: {addConnection,removeConnection}
+    } = useConnections(map,shapeInfo,setShapeInfo)
+
+
+    useModalEvent((event) => {
+        const shape = event.detail.room;
+        setShape(shape);
+        setShapeInfo({
+            ...shape.info,
+            selectedPin: ""
+
+        })
+        const connections = shape.info.selectedPins || [];
+        setConnections(connections);
+        setIsOpen(true);
+        console.log(connections, "Loaded pins on modal open");
+    },"openEntranceModalEvent")
+
+
+
+    return (
+        <Modal isOpen={isOpen} toggleModal={toggleModal} title={"Enter Entrance Details"}>
+            <ModalNameField shapeInfo={shapeInfo} updateModalData={updateModalData}/>
+            <ModalSelectRoom shapeInfo={shapeInfo} availableRooms={ShapeQuery.findAllByTypeAndFloor(shape?.floorNum,"Room")} updateModalData={updateModalData}/>
+            <ModalSelectConnections2
+                availableShapes={ShapeQuery.findAllByType("InfoPin","Entrance")} // najubo ke e entrance samo so room da mozit
+                addConnection={addConnection}
+                updateModalData={updateModalData}
+                shapeInfo={shapeInfo}
+            />
+            <ModalDisplayConnections connections={connections} removePinFromList={removeConnection}/>
+            <ModalDescriptionField shapeInfo={shapeInfo} updateModalData={updateModalData}/>
+            <ModalMainEntranceCheckbox shapeInfo={shapeInfo} updateModalData={updateModalData}></ModalMainEntranceCheckbox>
+            <ModalSaveButton saveDetails={saveDetails}/>
+        </Modal>
+    );
+}
+
+EntranceModal.propTypes = {
+    map: PropTypes.instanceOf(MapBuilder),
+};
Index: imaps-frontend/src/components/Modals/Hooks/useConnections.jsx
===================================================================
--- imaps-frontend/src/components/Modals/Hooks/useConnections.jsx	(revision 0c6b92add4cfaedcb91bcd37b45849f142f7d152)
+++ imaps-frontend/src/components/Modals/Hooks/useConnections.jsx	(revision 0c6b92add4cfaedcb91bcd37b45849f142f7d152)
@@ -0,0 +1,45 @@
+import {useState} from "react";
+
+export default function useConnections(map,shapeInfo,setShapeInfo){
+    const [connections,setConnections] = useState([])
+
+    const addConnection = () => {
+        console.log("TOSKA",shapeInfo)
+        if (!shapeInfo.selectedPin || connections.includes(shapeInfo.selectedPin)) return;
+
+        setConnections((prevConn) => {
+            const updatedConnections = [...prevConn, shapeInfo.selectedPin];
+
+
+            setShapeInfo((prevShapeInfo) => ({
+                ...prevShapeInfo,
+                ["selectedPin"]: "",
+                ["selectedPins"]: updatedConnections,
+            }));
+
+            console.log(shapeInfo.name,shapeInfo.selectedPin,"TEST")
+
+            map.drawConnection(shapeInfo.name,shapeInfo.selectedPin);
+            return updatedConnections;
+        });
+    };
+
+    const removeConnection = (connToRemove) => {
+        setConnections((prevConn) => {
+            const updatedPins = prevConn.filter((pin) => pin !== connToRemove);
+            setShapeInfo((prevFormData) => ({
+                ...prevFormData,
+                selectedPins: updatedPins,
+            }));
+            return updatedPins;
+        });
+        map.removeConnection(shapeInfo.name, connToRemove);
+    };
+
+
+    return {
+        connectionState: {connections,setConnections},
+        handlers: {addConnection,removeConnection}
+
+    }
+}
Index: imaps-frontend/src/components/Modals/Hooks/useModalEvent.jsx
===================================================================
--- imaps-frontend/src/components/Modals/Hooks/useModalEvent.jsx	(revision 0c6b92add4cfaedcb91bcd37b45849f142f7d152)
+++ imaps-frontend/src/components/Modals/Hooks/useModalEvent.jsx	(revision 0c6b92add4cfaedcb91bcd37b45849f142f7d152)
@@ -0,0 +1,14 @@
+import {useEffect} from "react";
+
+export function useModalEvent(openModalHandler,eventName){
+    useEffect(() => {
+
+        if(eventName == null) return;
+
+        window.addEventListener(eventName, openModalHandler);
+
+        return () => {
+            window.removeEventListener(eventName, openModalHandler);
+        };
+    }, []);
+}
Index: imaps-frontend/src/components/Modals/Hooks/useModalState.jsx
===================================================================
--- imaps-frontend/src/components/Modals/Hooks/useModalState.jsx	(revision 0c6b92add4cfaedcb91bcd37b45849f142f7d152)
+++ imaps-frontend/src/components/Modals/Hooks/useModalState.jsx	(revision 0c6b92add4cfaedcb91bcd37b45849f142f7d152)
@@ -0,0 +1,40 @@
+import {useState} from "react";
+import triggerMapSave from "../../../scripts/util/triggerMapSave.js";
+
+export default function useModalState(map) {
+    const [isOpen, setIsOpen] = useState(false);
+    const [shape, setShape] = useState(null);
+    const [shapeInfo,setShapeInfo] = useState({});
+
+
+    const toggleModal = () => {
+        if (isOpen) {
+            shape.setInfo(shapeInfo);
+            map.updateRoomNames();
+            triggerMapSave();
+            console.log("SHAPE BEF CLOSE:",shape.info)
+        }
+        setIsOpen(!isOpen);
+    };
+
+    const updateModalData = (e) => {
+        const {name, value, type, checked} = e.target;
+        setShapeInfo(prevShapeInfo => ({
+                ...prevShapeInfo,
+                [name]: type === "checkbox" ? checked : value
+            }
+        ))
+        console.log("SHAPE INFO UPDATE",shape.info)
+    };
+
+    const saveDetails = () => {
+        if (shape) {
+            toggleModal();
+        }
+    };
+
+    return {
+        modalState: {isOpen, shapeInfo,setIsOpen, shape, setShape,setShapeInfo},
+        handlers: {toggleModal, updateModalData, saveDetails}
+    };
+}
Index: imaps-frontend/src/components/Modals/Hooks/useRoomTypes.jsx
===================================================================
--- imaps-frontend/src/components/Modals/Hooks/useRoomTypes.jsx	(revision 0c6b92add4cfaedcb91bcd37b45849f142f7d152)
+++ imaps-frontend/src/components/Modals/Hooks/useRoomTypes.jsx	(revision 0c6b92add4cfaedcb91bcd37b45849f142f7d152)
@@ -0,0 +1,19 @@
+import {useEffect} from "react";
+
+export default function useRoomTypes(formData,setFormData,roomTypes,setRoomTypes,map){
+
+    const addRoomType = () => {
+        if (!formData.type || roomTypes.includes(formData.type)) return;
+        // setRoomTypes((prevTypes) => [...prevTypes, formData.type]);
+        setFormData({ ...formData, type: "" });
+        map.addRoomType(formData.type);
+        console.log("TYPES" + map.roomTypes);
+    };
+
+    const removeRoomType = (typeToRemove) => {
+        map.removeRoomType(typeToRemove);
+        setRoomTypes((prevTypes) => prevTypes.filter((type) => type !== typeToRemove));
+    };
+
+    return {addRoomType,removeRoomType}
+}
Index: imaps-frontend/src/components/Modals/InfoPinModal/InfoPinModal.jsx
===================================================================
--- imaps-frontend/src/components/Modals/InfoPinModal/InfoPinModal.jsx	(revision 0c6b92add4cfaedcb91bcd37b45849f142f7d152)
+++ imaps-frontend/src/components/Modals/InfoPinModal/InfoPinModal.jsx	(revision 0c6b92add4cfaedcb91bcd37b45849f142f7d152)
@@ -0,0 +1,63 @@
+import React, {useState, useEffect} from "react";
+import styles from "./InfoPinModal.module.css";
+import PropTypes, {instanceOf} from "prop-types";
+import {MapBuilder} from "../../../scripts/main/MapBuilder.js";
+import ModalNameField from "../Components/ModalNameField.jsx";
+import ModalSelectConnections from "../Components/ModalSelectConnections.jsx";
+import ModalDisplayConnections from "../Components/ModalDisplayConnections.jsx";
+import ModalDescriptionField from "../Components/ModalDescriptionField.jsx";
+import ModalSaveButton from "../Components/ModalSaveButton.jsx";
+import Modal from "../Components/Modal.jsx";
+import useModalState from "../Hooks/useModalState.jsx";
+import useConnections from "../Hooks/useConnections.jsx";
+import {useModalEvent} from "../Hooks/useModalEvent.jsx";
+import ModalSelectConnections2 from "../Components/ModalSelectConnections2.jsx";
+import ShapeQuery from "../../../scripts/util/ShapeQuery.js";
+
+export default function InfoPinModal({map}) {
+
+    const {
+        modalState: {isOpen,shapeInfo,shape,setIsOpen,setShape,setShapeInfo},
+        handlers: {toggleModal,updateModalData,saveDetails}
+    } = useModalState(map);
+
+    const {
+        connectionState: {connections,setConnections},
+        handlers: {addConnection,removeConnection}
+    } = useConnections(map,shapeInfo,setShapeInfo)
+
+
+    useModalEvent((event) => {
+        const shape = event.detail.room;
+        setShape(shape);
+        setShapeInfo({
+            ...shape.info,
+            selectedPin: ""
+        })
+        setConnections(shape.info.selectedPins || []);
+        setIsOpen(true);
+
+        console.log(shape.info.selectedPins, "Loaded pins on modal open");
+    },"openPinModalEvent")
+
+
+    return (
+        <Modal isOpen={isOpen} toggleModal={toggleModal} title={"Enter Pin Details"}>
+            <ModalNameField shapeInfo={shapeInfo} updateModalData={updateModalData}/>
+            <ModalSelectConnections2
+                shapeInfo={shapeInfo}
+                availableShapes={ShapeQuery.findAllByTypeAndFloor(map?.floorNum,"Stairs","InfoPin","Entrance")}
+                updateModalData={updateModalData}
+                addConnection={addConnection}
+            />
+            <ModalDisplayConnections connections={connections} removePinFromList={removeConnection}/>
+            <ModalDescriptionField shapeInfo={shapeInfo} updateModalData={updateModalData}/>
+            <ModalSaveButton saveDetails={saveDetails}/>
+        </Modal>
+
+    );
+}
+
+InfoPinModal.propTypes = {
+    map: PropTypes.instanceOf(MapBuilder),
+};
Index: imaps-frontend/src/components/Modals/RoomModal/RoomModal.jsx
===================================================================
--- imaps-frontend/src/components/Modals/RoomModal/RoomModal.jsx	(revision 0c6b92add4cfaedcb91bcd37b45849f142f7d152)
+++ imaps-frontend/src/components/Modals/RoomModal/RoomModal.jsx	(revision 0c6b92add4cfaedcb91bcd37b45849f142f7d152)
@@ -0,0 +1,35 @@
+import React, {useState, useEffect} from "react";
+import ModalNameField from "../Components/ModalNameField.jsx";
+import ModalDescriptionField from "../Components/ModalDescriptionField.jsx";
+import ModalSaveButton from "../Components/ModalSaveButton.jsx";
+import Modal from "../Components/Modal.jsx";
+import ModalRoomTypes from "../Components/ModalRoomTypes.jsx";
+import useModalState from "../Hooks/useModalState.jsx";
+import {useModalEvent} from "../Hooks/useModalEvent.jsx";
+
+export default function RoomModal({map,roomTypes}) {
+    const {
+        modalState: {isOpen,setIsOpen,setShape,shapeInfo,setShapeInfo},
+        handlers: {toggleModal,updateModalData,saveDetails}
+    } = useModalState(map);
+
+
+    useModalEvent((event) => {
+        const shape = event.detail.room;
+        setShape(shape);
+        setShapeInfo(shape.info);
+        setIsOpen(true);
+
+    },"openRoomModalEvent")
+
+
+
+    return (
+        <Modal isOpen={isOpen} toggleModal={toggleModal} title={"Enter Room Details"}>
+            <ModalNameField shapeInfo={shapeInfo} updateModalData={updateModalData}/>
+            <ModalRoomTypes updateModalData={updateModalData} shapeInfo={shapeInfo} roomTypes={roomTypes}/>
+            <ModalDescriptionField shapeInfo={shapeInfo} updateModalData={updateModalData}/>
+            <ModalSaveButton saveDetails={saveDetails}/>
+        </Modal>
+    );
+}
Index: imaps-frontend/src/components/Modals/RoomTypeModal/RoomTypeModal.jsx
===================================================================
--- imaps-frontend/src/components/Modals/RoomTypeModal/RoomTypeModal.jsx	(revision 0c6b92add4cfaedcb91bcd37b45849f142f7d152)
+++ imaps-frontend/src/components/Modals/RoomTypeModal/RoomTypeModal.jsx	(revision 0c6b92add4cfaedcb91bcd37b45849f142f7d152)
@@ -0,0 +1,76 @@
+import React, { useState, useEffect } from "react";
+import styles from "./RoomTypeModal.module.css";
+import useRoomTypes from "../Hooks/useRoomTypes.jsx";
+
+export default function RoomTypeModal({map,roomTypes,addRoomTypeDB}) {
+  const [modalIsOpen, setModalIsOpen] = useState(false);
+  const [roomTypeName, setRoomTypeName] = useState("");
+
+  const toggleModal = () => {
+    setModalIsOpen(!modalIsOpen);
+  };
+
+  const handleAddRoomType = async () => {
+    await addRoomTypeDB(roomTypeName);
+    setRoomTypeName("");
+  }
+  // Handle form input changes
+  const handleInputChange = (e) => {
+    const { name, value } = e.target;
+    setRoomTypeName(value);
+  };
+
+  return (
+    <>
+      <button onClick={toggleModal} className={styles.btnModal}>
+        Room Types
+      </button>
+
+      {modalIsOpen && (
+        <div className={styles.modal}>
+          <div onClick={toggleModal} className={styles.overlay}></div>
+          <div className={styles.modalContent}>
+            <h2>Manage Room Types</h2>
+
+            <form className={styles.form}>
+              <div className={styles.formGroup}>
+                <label htmlFor="roomTypeName">Add New Room Type:</label>
+                <input
+                  type="text"
+                  id="roomTypeName"
+                  name="roomTypeName"
+                  value={roomTypeName}
+                  onChange={handleInputChange}
+                  placeholder="Enter a new room type (e.g., Office, Classroom)"
+                />
+                <button type="button" className={styles.addButton} onClick={handleAddRoomType}>
+                  Add Type
+                </button>
+              </div>
+            </form>
+
+            <h3>Available Room Types:</h3>
+            <ul className={styles.roomTypeList}>
+              {roomTypes.length > 0 ? (
+                roomTypes.map((roomType,index) => (
+                  <li key={index} className={styles.roomTypeItem}>
+                    {roomType.name}
+                    <button className={styles.removeButton} >
+                      Remove
+                    </button>
+                  </li>
+                ))
+              ) : (
+                <li>No room types available</li>
+              )}
+            </ul>
+
+            <button className={styles.closeModal} onClick={toggleModal}>
+              CLOSE
+            </button>
+          </div>
+        </div>
+      )}
+    </>
+  );
+}
Index: imaps-frontend/src/components/Modals/StairsModal/StairsModal.jsx
===================================================================
--- imaps-frontend/src/components/Modals/StairsModal/StairsModal.jsx	(revision 0c6b92add4cfaedcb91bcd37b45849f142f7d152)
+++ imaps-frontend/src/components/Modals/StairsModal/StairsModal.jsx	(revision 0c6b92add4cfaedcb91bcd37b45849f142f7d152)
@@ -0,0 +1,54 @@
+import React, {useState} from "react";
+import useModalState from "../Hooks/useModalState.jsx";
+import {useModalEvent} from "../Hooks/useModalEvent.jsx";
+import useConnections from "../Hooks/useConnections.jsx";
+import ModalNameField from "../Components/ModalNameField.jsx";
+
+import ModalDisplayConnections from "../Components/ModalDisplayConnections.jsx";
+import ModalDescriptionField from "../Components/ModalDescriptionField.jsx";
+import ModalSaveButton from "../Components/ModalSaveButton.jsx";
+import Modal from "../Components/Modal.jsx";
+import ModalSelectConnections2 from "../Components/ModalSelectConnections2.jsx";
+import ShapeRegistry from "../../../scripts/util/ShapeRegistry.js";
+import ShapeQuery from "../../../scripts/util/ShapeQuery.js";
+
+export default function StairsModal({map}){
+    const {
+        modalState: {isOpen,setIsOpen,setShape,shapeInfo,setShapeInfo},
+        handlers: {toggleModal,updateModalData,saveDetails}
+    } = useModalState(map);
+
+    const {
+        connectionState: {connections,setConnections},
+        handlers: {addConnection,removeConnection}
+    } = useConnections(map,shapeInfo,setShapeInfo)
+
+
+    useModalEvent((event) => {
+        const roomObj = event.detail.room;
+        setShape(roomObj);
+        setShapeInfo(roomObj.info);
+        console.log("stairs connections shape info: " + roomObj.info.selectedPins)
+        setConnections(roomObj.info.selectedPins || []);
+        setIsOpen(true);
+        console.log(roomObj.info.selectedPins, "Loaded pins on modal open");
+    },"openStairsModalEvent")
+
+
+
+    return (
+
+        <Modal isOpen={isOpen} toggleModal={toggleModal} title={"Enter Stair Details"}>
+            <ModalNameField shapeInfo={shapeInfo} updateModalData={updateModalData} phtext={"Enter name of stairs"}/>
+            <ModalSelectConnections2
+                shapeInfo={shapeInfo}
+                updateModalData={updateModalData}
+                addConnection={addConnection}
+                availableShapes={ShapeQuery.findAllByType("Stairs")}
+            />
+            <ModalDisplayConnections connections={connections} removePinFromList={removeConnection}/>
+            <ModalDescriptionField shapeInfo={shapeInfo} updateModalData={updateModalData}/>
+            <ModalSaveButton saveDetails={saveDetails}/>
+        </Modal>
+    )
+}
Index: imaps-frontend/src/components/Profile/Profile.jsx
===================================================================
--- imaps-frontend/src/components/Profile/Profile.jsx	(revision d56544918790c0c3bc50f2f0a98c99f3d2988ccf)
+++ imaps-frontend/src/components/Profile/Profile.jsx	(revision 0c6b92add4cfaedcb91bcd37b45849f142f7d152)
@@ -1,52 +1,70 @@
-import React, { useState, useRef, useEffect } from "react";
+import React, { useState, useRef, useEffect, useContext } from "react";
+import { useNavigate, Link } from "react-router-dom";
 import profile from "../../assets/person_icon.png";
 import styles from "./Profile.module.css";
+import { useAppContext } from "../AppContext/AppContext.jsx";
 
-function Profile() {
-  const menus = ["Profile", "Settings", "Support", "Logout"];
-  const [open, setOpen] = useState(false);
-  const menuRef = useRef(null);
-  const imgRef = useRef(null);
+function Profile({ position = "fixed" }) {
+    const { username, isAuthenticated } = useAppContext();
+    const [open, setOpen] = useState(false);
+    const menuRef = useRef(null);
+    const imgRef = useRef(null);
+    const navigate = useNavigate();
 
-  useEffect(() => {
-    const handleClickOutside = (e) => {
-      if (menuRef.current && imgRef.current) {
-        if (!menuRef.current.contains(e.target) && !imgRef.current.contains(e.target)) {
-          setOpen(false);
+    const menus = isAuthenticated ? ["My Maps", "Logout"] : ["Login"];
+
+    useEffect(() => {
+        const handleClickOutside = (e) => {
+            if (menuRef.current && imgRef.current) {
+                if (!menuRef.current.contains(e.target) && !imgRef.current.contains(e.target)) {
+                    setOpen(false);
+                }
+            }
+        };
+
+        document.addEventListener("click", handleClickOutside);
+
+        return () => {
+            document.removeEventListener("click", handleClickOutside);
+        };
+    }, []);
+
+    const handleMenuClick = (menu) => {
+        if (menu === "My Maps") {
+            navigate("/MyMaps");
+        } else if (menu === "Logout") {
+            localStorage.removeItem("token");
+            window.location.reload();
         }
-      }
+        setOpen(false);
     };
 
-    document.addEventListener("click", handleClickOutside);
-
-    return () => {
-      document.removeEventListener("click", handleClickOutside);
-    };
-  }, []);
-
-  return (
-    <div className={styles.profileContainer}>
-      <div className={styles.profileWrapper}>
-        <img
-          onClick={() => setOpen(!open)}
-          src={profile}
-          alt="profile"
-          className={styles.profileImage}
-          ref={imgRef}
-        />
-        {open && (
-          <div ref={menuRef} className={styles.dropdownMenu}>
-            <ul className={styles.menuList}>
-              {menus.map((menu) => (
-                <li key={menu} onClick={() => setOpen(false)} className={styles.menuItem}>
-                  {menu}
-                </li>
-              ))}
-            </ul>
-          </div>
-        )}
-      </div>
-    </div>
-  );
+    return (
+        <div className={position === "fixed" ? styles.fixedProfileContainer : styles.inlineProfileContainer}>
+            <div className={styles.profileWrapper}>
+                <div className={styles.profileIconContainer} onClick={() => setOpen(!open)}>
+                    <img src={profile} alt="profile" className={styles.profileImage} ref={imgRef} />
+                </div>
+                {open && (
+                    <div ref={menuRef} className={styles.dropdownMenu}>
+                        {isAuthenticated && <div className={styles.username}>{username}</div>}
+                        <ul className={styles.menuList}>
+                            {menus.map((menu) =>
+                                menu === "Login" ? (
+                                    <li key={menu} className={styles.menuItem}>
+                                        <Link to="/login" className={styles.linkStyle}>{menu}</Link>
+                                    </li>
+                                ) : (
+                                    <li key={menu} onClick={() => handleMenuClick(menu)} className={styles.menuItem}>
+                                        {menu}
+                                    </li>
+                                )
+                            )}
+                        </ul>
+                    </div>
+                )}
+            </div>
+        </div>
+    );
 }
 
Index: imaps-frontend/src/components/ProtectedRoute/ProtectedRoute.jsx
===================================================================
--- imaps-frontend/src/components/ProtectedRoute/ProtectedRoute.jsx	(revision d56544918790c0c3bc50f2f0a98c99f3d2988ccf)
+++ imaps-frontend/src/components/ProtectedRoute/ProtectedRoute.jsx	(revision 0c6b92add4cfaedcb91bcd37b45849f142f7d152)
@@ -1,7 +1,25 @@
-import React from "react";
-import { Outlet, Navigate } from "react-router-dom";
+import { Navigate, Outlet, useLocation } from "react-router-dom";
+import {useAppContext} from "../AppContext/AppContext.jsx";
+import HttpService from "../../scripts/net/HttpService.js";
+import React, {useEffect} from "react";
+import {LoadingContainer} from "../LoadingContainer/LoadingContainer.jsx";
+import config from "../../scripts/net/netconfig.js";
+import {verifyToken} from "../../scripts/util/verifyToken.js";
 
-const ProtectedRoute = ({ isAuthenticated }) => {
-  return isAuthenticated ? <Outlet /> : <Navigate to="/Login" />;
+const ProtectedRoute = () => {
+  const location = useLocation();
+  const {loading,isAuthenticated} = useAppContext();
+
+
+  if(loading){
+    return <LoadingContainer/>
+  }
+
+
+  if (!isAuthenticated) {
+    return <Navigate to="/Login" state={{ targetPath: location }} replace />;
+  }
+
+  return <Outlet />;
 };
 
